#include <stdint.h>
#include <iostream>

#define CATCH_CONFIG_MAIN
#include "catch.hpp"
#include "simple_tests.h"
#include "advanced_instructions.h"

TEST_CASE("Simple functions work as expected, unhooked") {
	REQUIRE(_small() == 0);

	REQUIRE(_branch(1) == 0);
	REQUIRE(_branch(0) == 0);

	for (int i = 0; i < 1000; i++) {
		REQUIRE(_rip_relative() == rand());
	}
}

TEST_CASE("Advanced instruction functions work as expected, unhokked") {
	double result[4];
	_AVX(9., static_cast<void*>(result));
	REQUIRE((result[0] - result[1]) < DBL_EPSILON);
	REQUIRE((result[1] - result[2]) < DBL_EPSILON);
	REQUIRE((result[2] - result[3]) < DBL_EPSILON);
	REQUIRE((result[0] - 3.) < DBL_EPSILON);
}